package cn.estsh.i3plus.pojo.base.enumutil;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.apache.commons.lang3.StringUtils;

/**
 * @Description :
 * @Reference :
 * @Author : silliter
 * @CreateDate : 2019-05-13 15:53
 * @Modify:
 **/
public class AndonEnumUtil {

    /**
     * 标准处理 = 10，自处理 = 20
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum DISPOSAL_TYPE{
        STANDARD("10","标准处理"),
        SELF("20","自处理");

        private String value;
        private String description;

        DISPOSAL_TYPE(String value, String description) {
            this.value = value;
            this.description = description;
        }

        public String getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfDescription(String val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (StringUtils.equalsIgnoreCase(values()[i].value,val)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 审批状态：10=待审批，20=二级审批，30=三级审批，40=四级审批，100=已审批
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum APPROVAL_STATUS{
        WAIT("10","待审批"),
        SECOND_APPROVAL("20","二级审批"),
        THIRD_APPROVAL("30","三级审批"),
        FOUTH_APPROVAL("40","四级审批"),
        FINISH("60","已审批");

        private String value;
        private String description;

        APPROVAL_STATUS(String value, String description) {
            this.value = value;
            this.description = description;
        }

        public String getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfDescription(String val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (StringUtils.equalsIgnoreCase(values()[i].value,val)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 按灯状态
     * 10-是，20-否
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ALARM_STATUS {
        YES(10,"需要按灯"),
        ON(20,"不需要按灯");

        private int value;
        private String description;

        ALARM_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 按灯业务状态
     * 安灯状态=10，工号 =20 ，读取状态=30, 停线=40, 安灯子类型=50, 原因代码=60
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ALARM_BUSI_FLAG{
        ALARM_FLAG("10","安灯呼叫标识"),
        USER_CODE("20","用户工号"),
        READ_FLAG("30", "安灯读取状态"),
        STOP_FLAG("40", "停线状态"),
        DETAIL_TYPE("50", "安灯子类型"),
        AC_CODE("60", "原因代码");

        private String value;
        private String description;

        ALARM_BUSI_FLAG(String value, String description) {
            this.value = value;
            this.description = description;
        }

        public String getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }
    }

    /**
     * 按灯标识
     * 1-呼叫，2-签到，3-解决
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ANDON_ACTION_TAG {
        CALL(1,"10","呼叫"),
        SIGN(2,"20","响应"),
        RESOLVE(3,"30","解决"),
        CANCEL(4,"40", "撤销"),
        COMMIT(5,"50","提交"),
        PASS(6,"60","审批");

        private int value;
        private String code;
        private String description;

        ANDON_ACTION_TAG(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getCode(){ return code; }

        public String getDescription() {
            return description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }



    /**
     * 优先级别
     * 10 - 一级，20 - 二级，30 - 三级
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ALARM_PRIORITY{
        FIRST(10,"一级"),
        SECOND(20,"二级"),
        THIRD(30,"三级");

        private int value;
        private String description;

        ALARM_PRIORITY(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }




    /**
     * ANDON类型：MM=物料 QM=质量 EQ=设备 GY=工艺 JC=检测
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ALARM_TYPE {
        PART("PART_ALARM","物料"),
        QUALITY("QUALITY_ALARM","质量"),
        EQUIP("EQUMENT_ALARM","设备"),
        PROCESS("ROUTING_ALARM","工艺"),
        CHECK("OTHER_ALARM","其他");

        private String value;
        private String description;

        ALARM_TYPE(String value, String description) {
            this.value = value;
            this.description = description;
        }

        public String getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfDescription(String val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (StringUtils.equalsIgnoreCase(values()[i].value, val)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 组织模型树形菜单level
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum PROD_ORG_LEVEL{
        LEVEL_ONE(1,"一级目录"),
        LEVEL_TWO(2,"二级目录"),
        LEVEL_THREE(3,"三级目录"),
        LEVEL_FOUR(4,"四级目录");

        private int value;
        private String description;

        PROD_ORG_LEVEL(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val ) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 按灯停线标识
     * 1-停止产线，0-启动产线
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum STOP_LINE_FLAG{
        STOP("1","停止产线"),
        RESTART("0","启动产线");

        private String value;
        private String description;

        STOP_LINE_FLAG(String value, String description) {
            this.value = value;
            this.description = description;
        }

        public String getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }
    }

    /**
     * 按灯通知方式
     * 10-短信，20-邮箱
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum NOTICE_MESSAGE_SEND_TYPE {
        SMS("10","短信"),
        EMAIL("20","邮箱");

        private String value;
        private String description;

        NOTICE_MESSAGE_SEND_TYPE(String value, String description) {
            this.value = value;
            this.description = description;
        }

        public String getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }
    }

    /**
     * 通知级别
     * 10 - 一级，20 - 二级，30 - 三级，40 - 四级
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum NOTICE_MESSAGE_SEND_LEVEL {
        FIRST(10,"一级"),
        SECOND(20,"二级"),
        THIRD(30,"三级"),
        FOUTH(40,"四级");

        private int value;
        private String description;

        NOTICE_MESSAGE_SEND_LEVEL(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 安灯动作
     * <per>
     *     <br/> 10 = 呼叫
     *     <br/> 20 = 签到
     *     <br/> 30 = 解决
     *     <br/> 40 = 撤销
     *     <br/> 50 = 提交
     *     <br/> 60 = 审批
     *     <br/> 70 = 转呼
     * </per>
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ANDON_ACTION_FLAG{
        CALL_ACTION("10","呼叫动作"),
        SIGN_ACTION("20","签到动作"),
        RESOLVE_ACTION("30", "解决动作"),
        CANCEL_ACTION("40", "撤销动作"),
        COMMIT_ACTION("50","提交动作"),
        PASS_ACTION("60","审批动作"),
        SHIFG_CALL_ACTION("70", "转呼动作");

        private String value;
        private String description;

        ANDON_ACTION_FLAG(String value, String description) {
            this.value = value;
            this.description = description;
        }

        public String getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }
    }

    /**
     * 安灯重要等级
     * <per>
     *     <br/> 10 = 一级
     *     <br/> 20 = 二级
     *     <br/> 30 = 三级
     *     <br/> 40 = 四级
     * </per>
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ANDON_IMPORTANCE_LEVEL{
        FIRST_LEVEL("10","一级"),
        SECOND_LEVEL("20","二级"),
        THIRD_LEVEL("30","三级"),
        FORTH_LEVEL("40","四级");

        private String value;
        private String description;

        ANDON_IMPORTANCE_LEVEL(String value,String description) {
            this.value = value;
            this.description = description;
        }

        public String getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }
    }
}
